# Issue and Pull Request Guidelines

Thank you for getting involved in making Nokogiri better!


## Code of Conduct

For best results, be nice. Remember that Nokogiri maintainers are
volunteers, and treat them with respect.

Do not act entitled to service. Do not be rude. Do not use judgmental
or foul language.

The maintainers reserve the right to delete comments that are rude, or
that contain foul language. The maintainers reserve the right to
delete comments that they deem harassing or offensive.


## Issues

Please read the
["Getting Help" tutorial](http://www.nokogiri.org/tutorials/getting_help.html)
at the [nokogiri.org](http://nokogiri.org) site.

If you're reporting an issue, it must contain:

* Example code that reproduces the **observed** behavior.
* An explanation of what the **expected** behavior is.

That's it. If you don't provide that information, we'll ask you for
it, tag the story "needs more information", and then after a time will
close it if the information isn't provided.


## Pull Requests

Pull requests must always contain a test to prevent
regressions. Preferably, the test should demonstrate the __intent__ of
the code.

We may ask you for clarification if we don't understand the intent of
the change.
